#UART0
set_property PACKAGE_PIN L13 [get_ports UART_0_0_rxd]
set_property PACKAGE_PIN L14 [get_ports UART_0_0_txd]
set_property IOSTANDARD LVCMOS18 [get_ports UART_0_0_rxd]
set_property IOSTANDARD LVCMOS18 [get_ports UART_0_0_txd]

#SER0
set_property IOSTANDARD LVCMOS18 [get_ports SER0_CTS]
set_property IOSTANDARD LVCMOS18 [get_ports SER0_RTS]
set_property IOSTANDARD LVCMOS18 [get_ports SER0_RX]
set_property IOSTANDARD LVCMOS18 [get_ports SER0_TX]
set_property PACKAGE_PIN A14 [get_ports SER0_TX]
set_property PACKAGE_PIN B14 [get_ports SER0_RX]
set_property PACKAGE_PIN A15 [get_ports SER0_RTS]
set_property PACKAGE_PIN B15 [get_ports SER0_CTS]

#SER2
set_property IOSTANDARD LVCMOS18 [get_ports SER2_CTS]
set_property IOSTANDARD LVCMOS18 [get_ports SER2_RTS]
set_property IOSTANDARD LVCMOS18 [get_ports SER2_RX]
set_property IOSTANDARD LVCMOS18 [get_ports SER2_TX]
set_property PACKAGE_PIN C14 [get_ports SER2_CTS]
set_property PACKAGE_PIN C13 [get_ports SER2_RTS]
set_property PACKAGE_PIN D15 [get_ports SER2_RX]
set_property PACKAGE_PIN D14 [get_ports SER2_TX]

#IIC CAM0/CAM1/LCD
set_property PACKAGE_PIN A10 [get_ports i2c_cam0_sda_io]
set_property PACKAGE_PIN B10 [get_ports i2c_cam1_sda_io]
set_property PACKAGE_PIN C11 [get_ports i2c_lcd_scl_io]
set_property PACKAGE_PIN D11 [get_ports i2c_lcd_sda_io]
set_property IOSTANDARD LVCMOS18 [get_ports i2c_lcd_scl_io]
set_property IOSTANDARD LVCMOS18 [get_ports i2c_lcd_sda_io]
set_property IOSTANDARD LVCMOS18 [get_ports i2c_cam1_scl_io]
set_property IOSTANDARD LVCMOS18 [get_ports i2c_cam1_sda_io]
set_property IOSTANDARD LVCMOS18 [get_ports i2c_cam0_scl_io]
set_property IOSTANDARD LVCMOS18 [get_ports i2c_cam0_sda_io]
set_property PACKAGE_PIN B11 [get_ports i2c_cam1_scl_io]
set_property PACKAGE_PIN A12 [get_ports i2c_cam0_scl_io]

#CAN0
set_property IOSTANDARD LVCMOS18 [get_ports CAN_0_0_rx]
set_property IOSTANDARD LVCMOS18 [get_ports CAN_0_0_tx]
set_property PACKAGE_PIN AE13 [get_ports CAN_0_0_rx]
set_property PACKAGE_PIN AF13 [get_ports CAN_0_0_tx]

#MDIO0
set_property IOSTANDARD LVCMOS33 [get_ports MDIO_ENET0_0_mdc]
set_property IOSTANDARD LVCMOS33 [get_ports MDIO_ENET0_0_mdio_io]
set_property PACKAGE_PIN AC11 [get_ports MDIO_ENET0_0_mdc]
set_property PACKAGE_PIN AB11 [get_ports MDIO_ENET0_0_mdio_io]

#MDIO1
set_property IOSTANDARD LVCMOS33 [get_ports MDIO_ENET2_0_mdc]
set_property IOSTANDARD LVCMOS33 [get_ports MDIO_ENET2_0_mdio_io]
set_property PACKAGE_PIN AD10 [get_ports MDIO_ENET2_0_mdc]
set_property PACKAGE_PIN AD11 [get_ports MDIO_ENET2_0_mdio_io]


#I2C0
set_property IOSTANDARD LVCMOS18 [get_ports IIC_0_0_scl_io]
set_property IOSTANDARD LVCMOS18 [get_ports IIC_0_0_sda_io]
set_property PACKAGE_PIN D12 [get_ports IIC_0_0_scl_io]
set_property PACKAGE_PIN A11 [get_ports IIC_0_0_sda_io]
set_property SLEW FAST [get_ports IIC_0_0_scl_io]
set_property SLEW FAST [get_ports IIC_0_0_sda_io]

#Display Port
set_property PACKAGE_PIN Y10 [get_ports DP_DIN]
set_property IOSTANDARD LVCMOS33 [get_ports DP_DIN]
set_property PACKAGE_PIN Y9 [get_ports DP_OUT]
set_property IOSTANDARD LVCMOS33 [get_ports DP_OUT]
set_property PACKAGE_PIN AA8 [get_ports {DP_OE[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {DP_OE[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports DP_HPD]
set_property PACKAGE_PIN C12 [get_ports DP_HPD]

#PCIE lanes LOC
#set_property LOC GTHE4_CHANNEL_X0Y4 [get_cells {*_i/xdma_0/inst/pcie4_ip_i/inst/gt_top_i/diablo_gt.diablo_gt_phy_wrapper/gt_wizard.gtwizard_top_i/*_xdma_0_0_pcie4_ip_gt_i/inst/gen_gtwizard_gthe4_top.*_xdma_0_0_pcie4_ip_gt_gtwizard_gthe4_inst/gen_gtwizard_gthe4.gen_channel_container[1].gen_enabled_channel.gthe4_channel_wrapper_inst/channel_inst/gthe4_channel_gen.gen_gthe4_channel_inst[0].GTHE4_CHANNEL_PRIM_INST}]
#set_property LOC GTHE4_CHANNEL_X0Y5 [get_cells {*_i/xdma_0/inst/pcie4_ip_i/inst/gt_top_i/diablo_gt.diablo_gt_phy_wrapper/gt_wizard.gtwizard_top_i/*_xdma_0_0_pcie4_ip_gt_i/inst/gen_gtwizard_gthe4_top.*_xdma_0_0_pcie4_ip_gt_gtwizard_gthe4_inst/gen_gtwizard_gthe4.gen_channel_container[1].gen_enabled_channel.gthe4_channel_wrapper_inst/channel_inst/gthe4_channel_gen.gen_gthe4_channel_inst[1].GTHE4_CHANNEL_PRIM_INST}]
#set_property LOC GTHE4_CHANNEL_X0Y6 [get_cells {*_i/xdma_0/inst/pcie4_ip_i/inst/gt_top_i/diablo_gt.diablo_gt_phy_wrapper/gt_wizard.gtwizard_top_i/*_xdma_0_0_pcie4_ip_gt_i/inst/gen_gtwizard_gthe4_top.*_xdma_0_0_pcie4_ip_gt_gtwizard_gthe4_inst/gen_gtwizard_gthe4.gen_channel_container[1].gen_enabled_channel.gthe4_channel_wrapper_inst/channel_inst/gthe4_channel_gen.gen_gthe4_channel_inst[2].GTHE4_CHANNEL_PRIM_INST}]
#set_property LOC GTHE4_CHANNEL_X0Y7 [get_cells {*_i/xdma_0/inst/pcie4_ip_i/inst/gt_top_i/diablo_gt.diablo_gt_phy_wrapper/gt_wizard.gtwizard_top_i/*_xdma_0_0_pcie4_ip_gt_i/inst/gen_gtwizard_gthe4_top.*_xdma_0_0_pcie4_ip_gt_gtwizard_gthe4_inst/gen_gtwizard_gthe4.gen_channel_container[1].gen_enabled_channel.gthe4_channel_wrapper_inst/channel_inst/gthe4_channel_gen.gen_gthe4_channel_inst[3].GTHE4_CHANNEL_PRIM_INST}]
#set_property LOC PCIE40E4_X0Y0 [get_cells *_i/xdma_0/inst/pcie4_ip_i/inst/pcie_4_0_pipe_inst/pcie_4_0_e4_inst]

#EMIO
#PCIE_A_RST#
set_property PACKAGE_PIN AE10 [get_ports {GPIO_0_0_tri_io[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {GPIO_0_0_tri_io[0]}]
#Misc
set_property PACKAGE_PIN W10 [get_ports {GPIO_0_0_tri_io[1]}]
set_property PACKAGE_PIN AD12 [get_ports {GPIO_0_0_tri_io[2]}]
set_property PACKAGE_PIN AC12 [get_ports {GPIO_0_0_tri_io[3]}]
set_property PACKAGE_PIN AF12 [get_ports {GPIO_0_0_tri_io[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {GPIO_0_0_tri_io[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {GPIO_0_0_tri_io[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {GPIO_0_0_tri_io[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {GPIO_0_0_tri_io[1]}]

#AXI_GPIO_en_oc
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_usb_en_oc_tri_io[5]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_usb_en_oc_tri_io[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_usb_en_oc_tri_io[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_usb_en_oc_tri_io[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_usb_en_oc_tri_io[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_usb_en_oc_tri_io[0]}]
set_property PACKAGE_PIN AH11 [get_ports {gpio_usb_en_oc_tri_io[0]}]
set_property PACKAGE_PIN AH12 [get_ports {gpio_usb_en_oc_tri_io[1]}]
set_property PACKAGE_PIN AG11 [get_ports {gpio_usb_en_oc_tri_io[2]}]
set_property PACKAGE_PIN AF11 [get_ports {gpio_usb_en_oc_tri_io[3]}]
set_property PACKAGE_PIN AH10 [get_ports {gpio_usb_en_oc_tri_io[4]}]
set_property PACKAGE_PIN AG10 [get_ports {gpio_usb_en_oc_tri_io[5]}]
set_property PULLUP true [get_ports {gpio_usb_en_oc_tri_io[2]}]

#AXI_GPIO_MISC
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_misc_tri_io[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_misc_tri_io[1]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_misc_tri_io[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_misc_tri_io[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_misc_tri_io[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_misc_tri_io[5]}]
set_property IOSTANDARD LVCMOS33 [get_ports {gpio_misc_tri_io[6]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_misc_tri_io[7]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_misc_tri_io[8]}]
set_property PACKAGE_PIN AD15 [get_ports {gpio_misc_tri_io[0]}]
set_property PACKAGE_PIN K14 [get_ports {gpio_misc_tri_io[1]}]
set_property PACKAGE_PIN J14 [get_ports {gpio_misc_tri_io[2]}]
set_property PACKAGE_PIN AE12 [get_ports {gpio_misc_tri_io[3]}]
set_property PACKAGE_PIN AA11 [get_ports {gpio_misc_tri_io[4]}]
set_property PACKAGE_PIN AA10 [get_ports {gpio_misc_tri_io[5]}]
set_property PACKAGE_PIN AB10 [get_ports {gpio_misc_tri_io[6]}]
set_property PACKAGE_PIN E2 [get_ports {gpio_misc_tri_io[7]}]
set_property PACKAGE_PIN F2 [get_ports {gpio_misc_tri_io[8]}]

#AXI_GPIO_LVDS0/1
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[12]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[11]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[10]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[9]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[8]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[7]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[6]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[5]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[4]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[3]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[2]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[1]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds0_tri_io[0]}]
set_property PACKAGE_PIN AH13 [get_ports {lvds0_tri_io[0]}]
set_property PACKAGE_PIN AH14 [get_ports {lvds0_tri_io[1]}]
set_property PACKAGE_PIN AE14 [get_ports {lvds0_tri_io[2]}]
set_property PACKAGE_PIN C4 [get_ports {lvds0_tri_io[3]}]
set_property PACKAGE_PIN D4 [get_ports {lvds0_tri_io[4]}]
set_property PACKAGE_PIN A4 [get_ports {lvds0_tri_io[5]}]
set_property PACKAGE_PIN B4 [get_ports {lvds0_tri_io[6]}]
set_property PACKAGE_PIN A3 [get_ports {lvds0_tri_io[7]}]
set_property PACKAGE_PIN B3 [get_ports {lvds0_tri_io[8]}]
set_property PACKAGE_PIN A1 [get_ports {lvds0_tri_io[9]}]
set_property PACKAGE_PIN A2 [get_ports {lvds0_tri_io[10]}]
set_property PACKAGE_PIN B1 [get_ports {lvds0_tri_io[11]}]
set_property PACKAGE_PIN C1 [get_ports {lvds0_tri_io[12]}]
set_property PACKAGE_PIN AG13 [get_ports {lvds1_tri_io[0]}]
set_property PACKAGE_PIN AG14 [get_ports {lvds1_tri_io[1]}]
set_property PACKAGE_PIN AE15 [get_ports {lvds1_tri_io[2]}]
set_property PACKAGE_PIN D9 [get_ports {lvds1_tri_io[3]}]
set_property PACKAGE_PIN E9 [get_ports {lvds1_tri_io[4]}]
set_property PACKAGE_PIN E8 [get_ports {lvds1_tri_io[5]}]
set_property PACKAGE_PIN F8 [get_ports {lvds1_tri_io[6]}]
set_property PACKAGE_PIN F7 [get_ports {lvds1_tri_io[7]}]
set_property PACKAGE_PIN G8 [get_ports {lvds1_tri_io[8]}]
set_property PACKAGE_PIN F6 [get_ports {lvds1_tri_io[9]}]
set_property PACKAGE_PIN G6 [get_ports {lvds1_tri_io[10]}]
set_property PACKAGE_PIN D5 [get_ports {lvds1_tri_io[11]}]
set_property PACKAGE_PIN E5 [get_ports {lvds1_tri_io[12]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[12]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[11]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[10]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[9]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[8]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[7]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[6]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[5]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[4]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[3]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[2]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[1]}]
set_property IOSTANDARD LVCMOS18 [get_ports {lvds1_tri_io[0]}]

#AXI_GPIO_CSI0/1
set_property DRIVE 8 [get_ports {CSI0_tri_io[5]}]
set_property DRIVE 8 [get_ports {CSI0_tri_io[4]}]
set_property DRIVE 8 [get_ports {CSI0_tri_io[3]}]
set_property DRIVE 8 [get_ports {CSI0_tri_io[2]}]
set_property DRIVE 8 [get_ports {CSI0_tri_io[1]}]
set_property DRIVE 8 [get_ports {CSI0_tri_io[0]}]
set_property PACKAGE_PIN L7 [get_ports {CSI0_tri_io[0]}]
set_property PACKAGE_PIN L6 [get_ports {CSI0_tri_io[1]}]
set_property PACKAGE_PIN M6 [get_ports {CSI0_tri_io[2]}]
set_property PACKAGE_PIN L5 [get_ports {CSI0_tri_io[3]}]
set_property PACKAGE_PIN N7 [get_ports {CSI0_tri_io[4]}]
set_property PACKAGE_PIN N6 [get_ports {CSI0_tri_io[5]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI0_tri_io[5]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI0_tri_io[4]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI0_tri_io[3]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI0_tri_io[2]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI0_tri_io[1]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI0_tri_io[0]}]
set_property PACKAGE_PIN J4 [get_ports {CSI1_tri_io[1]}]
set_property PACKAGE_PIN J6 [get_ports {CSI1_tri_io[2]}]
set_property PACKAGE_PIN H6 [get_ports {CSI1_tri_io[3]}]
set_property PACKAGE_PIN J7 [get_ports {CSI1_tri_io[4]}]
set_property PACKAGE_PIN H7 [get_ports {CSI1_tri_io[5]}]
set_property PACKAGE_PIN K8 [get_ports {CSI1_tri_io[6]}]
set_property PACKAGE_PIN K7 [get_ports {CSI1_tri_io[7]}]
set_property PACKAGE_PIN K9 [get_ports {CSI1_tri_io[8]}]
set_property PACKAGE_PIN J9 [get_ports {CSI1_tri_io[9]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[9]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[8]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[7]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[6]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[5]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[4]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[3]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[2]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[1]}]
set_property IOSTANDARD LVCMOS12 [get_ports {CSI1_tri_io[0]}]
set_property PACKAGE_PIN J5 [get_ports {CSI1_tri_io[0]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[9]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[8]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[7]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[6]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[5]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[4]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[3]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[2]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[1]}]
set_property DRIVE 8 [get_ports {CSI1_tri_io[0]}]

#AXI_GPIO_I2S0/1
set_property PACKAGE_PIN B5 [get_ports {i2s1_tri_io[0]}]
set_property PACKAGE_PIN A5 [get_ports {i2s1_tri_io[1]}]
set_property PACKAGE_PIN C6 [get_ports {i2s1_tri_io[2]}]
set_property PACKAGE_PIN B6 [get_ports {i2s1_tri_io[3]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s1_tri_io[3]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s1_tri_io[2]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s1_tri_io[1]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s1_tri_io[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s0_tri_io[4]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s0_tri_io[3]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s0_tri_io[2]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s0_tri_io[1]}]
set_property IOSTANDARD LVCMOS18 [get_ports {i2s0_tri_io[0]}]
set_property PACKAGE_PIN E15 [get_ports {i2s0_tri_io[0]}]
set_property PACKAGE_PIN F15 [get_ports {i2s0_tri_io[1]}]
set_property PACKAGE_PIN F13 [get_ports {i2s0_tri_io[2]}]
set_property PACKAGE_PIN G13 [get_ports {i2s0_tri_io[3]}]
set_property PACKAGE_PIN E13 [get_ports {i2s0_tri_io[4]}]

#AXI_GPIO_espi
set_property PACKAGE_PIN AA12 [get_ports {gpio_espi_tri_io[0]}]
set_property PACKAGE_PIN Y12 [get_ports {gpio_espi_tri_io[1]}]
set_property PACKAGE_PIN W11 [get_ports {gpio_espi_tri_io[2]}]
set_property PACKAGE_PIN W12 [get_ports {gpio_espi_tri_io[3]}]
set_property PACKAGE_PIN Y13 [get_ports {gpio_espi_tri_io[4]}]
set_property PACKAGE_PIN Y14 [get_ports {gpio_espi_tri_io[5]}]
set_property PACKAGE_PIN W13 [get_ports {gpio_espi_tri_io[6]}]
set_property PACKAGE_PIN W14 [get_ports {gpio_espi_tri_io[7]}]
set_property PACKAGE_PIN AB14 [get_ports {gpio_espi_tri_io[8]}]
set_property PACKAGE_PIN AB15 [get_ports {gpio_espi_tri_io[9]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[9]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[8]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[7]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[6]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[5]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[4]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[3]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[2]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[1]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_espi_tri_io[0]}]

#AXI_GPIO_bdrev

#AXI_GPIO_csi2_hdmi
set_property DRIVE 8 [get_ports {csi2_hdmi_tri_io[7]}]
set_property DRIVE 8 [get_ports {csi2_hdmi_tri_io[6]}]
set_property DRIVE 8 [get_ports {csi2_hdmi_tri_io[5]}]
set_property DRIVE 8 [get_ports {csi2_hdmi_tri_io[4]}]
set_property DRIVE 8 [get_ports {csi2_hdmi_tri_io[3]}]
set_property DRIVE 8 [get_ports {csi2_hdmi_tri_io[2]}]
set_property DRIVE 8 [get_ports {csi2_hdmi_tri_io[1]}]
set_property DRIVE 8 [get_ports {csi2_hdmi_tri_io[0]}]
set_property IOSTANDARD LVCMOS12 [get_ports {csi2_hdmi_tri_io[7]}]
set_property IOSTANDARD LVCMOS12 [get_ports {csi2_hdmi_tri_io[6]}]
set_property IOSTANDARD LVCMOS12 [get_ports {csi2_hdmi_tri_io[5]}]
set_property IOSTANDARD LVCMOS12 [get_ports {csi2_hdmi_tri_io[4]}]
set_property IOSTANDARD LVCMOS12 [get_ports {csi2_hdmi_tri_io[3]}]
set_property IOSTANDARD LVCMOS12 [get_ports {csi2_hdmi_tri_io[2]}]
set_property IOSTANDARD LVCMOS12 [get_ports {csi2_hdmi_tri_io[1]}]
set_property IOSTANDARD LVCMOS12 [get_ports {csi2_hdmi_tri_io[0]}]
set_property PACKAGE_PIN W8 [get_ports {csi2_hdmi_tri_io[0]}]
set_property PACKAGE_PIN Y8 [get_ports {csi2_hdmi_tri_io[1]}]
set_property PACKAGE_PIN U9 [get_ports {csi2_hdmi_tri_io[2]}]
set_property PACKAGE_PIN V9 [get_ports {csi2_hdmi_tri_io[3]}]
set_property PACKAGE_PIN U8 [get_ports {csi2_hdmi_tri_io[4]}]
set_property PACKAGE_PIN V8 [get_ports {csi2_hdmi_tri_io[5]}]
set_property PACKAGE_PIN R8 [get_ports {csi2_hdmi_tri_io[6]}]
set_property PACKAGE_PIN T8 [get_ports {csi2_hdmi_tri_io[7]}]

#AXI_GPIO_smarc
set_property PACKAGE_PIN F11 [get_ports {gpio_smarc_tri_io[0]}]
set_property PACKAGE_PIN F12 [get_ports {gpio_smarc_tri_io[1]}]
set_property PACKAGE_PIN F10 [get_ports {gpio_smarc_tri_io[2]}]
set_property PACKAGE_PIN G11 [get_ports {gpio_smarc_tri_io[3]}]
set_property PACKAGE_PIN H12 [get_ports {gpio_smarc_tri_io[4]}]
set_property PACKAGE_PIN J12 [get_ports {gpio_smarc_tri_io[5]}]
set_property PACKAGE_PIN G10 [get_ports {gpio_smarc_tri_io[6]}]
set_property PACKAGE_PIN H11 [get_ports {gpio_smarc_tri_io[7]}]
set_property PACKAGE_PIN K12 [get_ports {gpio_smarc_tri_io[8]}]
set_property PACKAGE_PIN K13 [get_ports {gpio_smarc_tri_io[9]}]
set_property PACKAGE_PIN J10 [get_ports {gpio_smarc_tri_io[10]}]
set_property PACKAGE_PIN J11 [get_ports {gpio_smarc_tri_io[11]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[11]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[10]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[9]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[8]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[7]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[6]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[5]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[4]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[3]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[2]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[1]}]
set_property IOSTANDARD LVCMOS18 [get_ports {gpio_smarc_tri_io[0]}]

set_property IOSTANDARD LVCMOS18 [get_ports {bd_rev_tri_io[3]}]
set_property IOSTANDARD LVCMOS18 [get_ports {bd_rev_tri_io[2]}]
set_property IOSTANDARD LVCMOS18 [get_ports {bd_rev_tri_io[1]}]
set_property IOSTANDARD LVCMOS18 [get_ports {bd_rev_tri_io[0]}]
set_property PACKAGE_PIN AC13 [get_ports {bd_rev_tri_io[3]}]
set_property PACKAGE_PIN AC14 [get_ports {bd_rev_tri_io[2]}]
set_property PACKAGE_PIN AB13 [get_ports {bd_rev_tri_io[1]}]
set_property PACKAGE_PIN AA13 [get_ports {bd_rev_tri_io[0]}]
